INCLUDE 	\masm32\include\masm32rt.inc 

.DATA 
hInputFile	DD ?
hOutputFile	DD ?
fileSize	DD ?
numRead		DD ?
numWritten	DD ?
inputFile	DB "Test.asm", 0
outputFile	DB "Copy.asm", 0
hStdOut		DD ?
hMemory		DD ?
errorNum	DD ?
errorBuffer	DB MAX_PATH DUP(?)

.CODE
start: 
	INVOKE	GetStdHandle, STD_OUTPUT_HANDLE	; -11
	MOV	hStdOut, EAX

   	INVOKE	CreateFile, 		\
   		OFFSET inputFile,	\
   		GENERIC_READ,		\
   		FILE_SHARE_READ,	\
   		NULL,			\
   		OPEN_EXISTING,		\
   		FILE_ATTRIBUTE_NORMAL,	\
   		NULL
	MOV	hInputFile, EAX
	CMP	hInputFile, INVALID_HANDLE_VALUE
	JE	errorProcess
	
   	INVOKE	CreateFile, 		\
   		OFFSET outputFile,	\
   		GENERIC_WRITE,		\
   		0,			\
   		NULL,			\
   		CREATE_ALWAYS,		\
   		FILE_ATTRIBUTE_NORMAL,	\
   		NULL
	MOV	hOutputFile, EAX
	CMP	hOutputFile, INVALID_HANDLE_VALUE
	JE	errorProcess		

	INVOKE 	GetFileSize, hInputFile, NULL
	MOV 	fileSize, EAX
	add eax, 127

	INVOKE 	GlobalAlloc, GMEM_FIXED, eax	; fileSize
    	MOV	hMemory, EAX
    	CMP	hMemory, 0
    	JE	errorProcess

	INVOKE 	ReadFile,	\
		hInputFile,	\
		hMemory,	\
      		fileSize,	\
      		ADDR numRead,	\
      		0
	CMP	EAX, 0
	JE	errorProcess
	mov ecx, fileSize
	.if ecx>50000
		mov ecx, 50000
	.endif
	INVOKE	WriteConsole, hStdOut, hMemory, ecx, addr numWritten, 0

	INVOKE	WriteFile,		\
		hOutputFile,		\
		hMemory,		\
		fileSize,		\
		ADDR numWritten,	\
		NULL
	mov eax, LastError$()
	CMP	EAX, 0
	JE	errorProcess
	
	JMP	finalise

errorProcess:
	INVOKE	GetLastError
	INVOKE	FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM, 0, EAX, 0, ADDR errorBuffer, MAX_PATH, 0
	INVOKE	WriteConsole, hStdOut, OFFSET errorBuffer, MAX_PATH, numWritten, 0
	
finalise:
	INVOKE 	GlobalFree, hMemory
	INVOKE	CloseHandle, hInputFile
	INVOKE	CloseHandle, hOutputFile
	INVOKE	ExitProcess, 0
	
END start

OPT_Tmp2Asm 1








